<?php

/*
 *  LMS Userpanel version 1.1-cvs
 *
 *  (C) Copyright 2004-2006 Userpanel Developers
 *
 *  Please, see the doc/AUTHORS for more information about authors!
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License Version 2 as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, 
 *  USA.
 *
 *  $Id: authentication.inc,v 1.8 2006/05/05 13:24:27 alec Exp $
 */

global $LMS;
if(version_compare($LMS->_version, '1.6.99')>0)
	define('CUSTOMERS_TABLE', 'customers');
else
	define('CUSTOMERS_TABLE', 'users');

function GetCustomerIDByPhone1AndPIN($phone1, $pin)
{
	global $DB;
	if(!ereg('^[0-9]+$', $pin))
		return NULL;
	$authinfo['id'] = $DB->GetOne('SELECT id from '.CUSTOMERS_TABLE.' WHERE phone1=?', array($phone1));
	if ($authinfo['id'] == NULL)
		return NULL;
	$authinfo['passwd'] = $DB->GetOne('SELECT pin from '.CUSTOMERS_TABLE.' WHERE pin=? AND phone1=?', array($pin, $phone1));
	return $authinfo;
}

function GetCustomerIDByIDAndPIN($id, $pin)
{
	global $DB;
	if(!ereg('^[0-9]+$', $pin) || !ereg('^[0-9]+$', $id))
		return NULL;
	$authinfo['id'] = $DB->GetOne('SELECT id from '.CUSTOMERS_TABLE.' WHERE id=?', array($id));
	if ($authinfo['id'] == NULL)
		return NULL;
	$authinfo['passwd'] = $DB->GetOne('SELECT pin from '.CUSTOMERS_TABLE.' WHERE pin=? AND id=?', array($pin, $id));
	return $authinfo;
}

// It requires "contract" field.
function GetCustomerIDByContractAndPIN($contract, $pin)
{
	global $DB;
	if(!ereg('^[0-9]+$', $pin))
		return NULL;
	$authinfo['id'] = $DB->GetOne('SELECT id FROM '.CUSTOMERS_TABLE.' WHERE contract=?', array($contract));
	if ($authinfo['id'] == NULL)
		return NULL;
	$authinfo['passwd'] = $DB->GetOne('SELECT pin FROM '.CUSTOMERS_TABLE.' WHERE pin=? AND contract=?', array($pin, $contract));
	return $authinfo;
}

function GetCustomerAuthInfo($customerid)
{
	global $DB;
	return $DB->GetRow('SELECT customerid AS id, lastlogindate, lastloginip, failedlogindate, failedloginip, enabled FROM up_customers WHERE customerid=?',
		array($customerid));
}

function SetCustomerAuthInfo($authinfo)
{
	global $DB;
	$actauthinfo = GetCustomerAuthInfo($authinfo['id']);
	if ($actauthinfo != null)
	{
		$DB->Execute('UPDATE up_customers SET lastlogindate=?, lastloginip=?, failedlogindate=?, failedloginip=?, enabled=? WHERE customerid=?',
			array($authinfo['lastlogindate'], $authinfo['lastloginip'], $authinfo['failedlogindate'], $authinfo['failedloginip'],
			$authinfo['enabled'], $authinfo['id']));
	}
	else
	{
		$DB->Execute('INSERT INTO up_customers(customerid, lastlogindate, lastloginip, failedlogindate, failedloginip, enabled) VALUES (?, ?, ?, ?, ?, ?)',
			array($authinfo['id'], $authinfo['lastlogindate'], $authinfo['lastloginip'],
			$authinfo['failedlogindate'], $authinfo['failedloginip'], $authinfo['enabled']));
	}
}

?>
