<?php

/*
 *  LMS Userpanel version 1.1-cvs
 *
 *  (C) Copyright 2004-2006 Userpanel Developers
 *
 *  Please, see the doc/AUTHORS for more information about authors!
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License Version 2 as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 *
 *  $Id: functions.php,v 1.16 2006/07/05 17:52:18 alec Exp $
 */

function module_main()
{
    global $LMS,$SMARTY,$SESSION;
    $userinfo = $LMS->GetCustomer($SESSION->id);
    $usernodes = $LMS->GetCustomerNodes($SESSION->id);
    $balancelist = $LMS->GetCustomerBalanceList($SESSION->id);
    $fields_changed = $LMS->DB->GetRow('SELECT id FROM up_info_changes WHERE customerid = ?', 
    	array($SESSION->id));
    
    $SMARTY->assign('userinfo',$userinfo);
    $SMARTY->assign('usernodes',$usernodes);
    $SMARTY->assign('balancelist',$balancelist);
    $SMARTY->assign('fields_changed', $fields_changed);
    $SMARTY->display('module:info.html');
} 

function module_updateuserform() 
{
    global $LMS,$SMARTY,$SESSION;
    $userinfo = $LMS->GetCustomer($SESSION->id);
    $usernodes = $LMS->GetCustomerNodes($SESSION->id);
    
    $SMARTY->assign('userinfo',$userinfo);
    $SMARTY->assign('usernodes',$usernodes);
    $SMARTY->display('module:updateuser.html');
}

function module_updateusersave() 
{
    global $LMS,$SMARTY,$SESSION, $rights, $error;
    $userinfo = $LMS->GetCustomer($SESSION->id);
    $userdata = $_POST['userdata'];
    if($userdata['im']=='') $userdata['im'] = 0;
    $right = $rights['info'];
    $id=$SESSION->id;
    $error=NULL;
    if(isset($right['edit_addr']) || 
	isset($right['edit_addr_ack']) ||
    	isset($right['edit_contact']) || 
	isset($right['edit_contact_ack'])
    )
	foreach(array_diff_assoc($userdata, $userinfo) as $field => $val) {
	    $val = htmlspecialchars($val, ENT_NOQUOTES);
            switch($field) {
		case 'name':
		case 'lastname':
		case 'address':
		case 'zip':
		case 'city':
		case 'phone1':
			if(isset($right['edit_addr']))
				$userinfo[$field] = $val;
			elseif(isset($right['edit_addr_ack']))
				$LMS->DB->Execute('INSERT INTO up_info_changes(customerid, fieldname, fieldvalue) 
					VALUES(?, ?, ?)', array($id, $field, $val));
			break;
		case 'ten':
			if($val!='' && !check_ten($val)) {
				$error['ten']=1;
			}
			else 
			{
				if(isset($right['edit_addr']))
					$userinfo[$field] = $val;
				elseif(isset($right['edit_addr_ack']))
					$LMS->DB->Execute('INSERT INTO up_info_changes(customerid, fieldname, fieldvalue) 
						VALUES(?, ?, ?)', array($id, $field, $val));
			}
			break;
		case 'ssn':
			if($val!='' && !check_ssn($val)) {
				$error['ssn']=1;
			}
			else 
			{
				if(isset($right['edit_addr']))
					$userinfo[$field] = $val;
				elseif(isset($right['edit_addr_ack']))
					$LMS->DB->Execute('INSERT INTO up_info_changes(customerid, fieldname, fieldvalue) 
						VALUES(?, ?, ?)', array($id, $field, $val));
			}
			break;
		case 'phone2':
		case 'phone3':
		case 'email':
		case 'im':
			if(isset($right['edit_contact']))
				$userinfo[$field] = $val;
			elseif(isset($right['edit_contact_ack']))
				$LMS->DB->Execute('INSERT INTO up_info_changes(customerid, fieldname, fieldvalue) 
					VALUES(?, ?, ?)', array($id, $field, $val));
			break;
		default:
			break;
	    }
	}
    if(isset($error)) {
    	$usernodes = $LMS->GetCustomerNodes($SESSION->id);
        $usernodes['ownerid'] = $_GET['id'];
        $SMARTY->assign('userinfo',$userinfo);
        $SMARTY->assign('usernodes',$usernodes);
	$SMARTY->assign('error',$error);
        $SMARTY->display('module:updateuser.html');
    }
    else
    {
        $LMS->CustomerUpdate($userinfo);
        header('Location: ?m=info');
    }
}

if(isset($_USERPANEL_SETUPMODE)) {
	function module_changes()
	{
		global $layout, $SMARTY, $DB, $LMS;
		$layout['pagetitle'] = trans('Changes affirmation');

		if(version_compare($LMS->_version, '1.6.99')>0)
			$userchanges = $DB->GetAll('SELECT up_info_changes.id, customerid, fieldname, fieldvalue AS newvalue, '.
				$DB->Concat('UPPER(lastname)',"' '",'customers.name').' AS customername FROM up_info_changes
				INNER JOIN customers ON customers.id=up_info_changes.customerid');
		else
			$userchanges = $DB->GetAll('SELECT up_info_changes.id, customerid, fieldname, fieldvalue AS newvalue, '.
				$DB->Concat('UPPER(lastname)',"' '",'users.name').' AS customername FROM up_info_changes
				INNER JOIN users ON users.id=up_info_changes.customerid');

		if(isset($userchanges))
			foreach($userchanges as $key => $change)
			{
				if(version_compare($LMS->_version, '1.6.99')>0)
			 		$old = $DB->GetRow('SELECT '.$change['fieldname'].' AS old FROM customers WHERE id = ?',
						array($change['customerid']));
				else
					$old = $DB->GetRow('SELECT '.$change['fieldname'].' AS old FROM users WHERE id = ?',
						array($change['customerid']));
						
				$userchanges[$key]['oldvalue'] = $old['old'];
			}

		$SMARTY->assign('userchanges', $userchanges);
		$SMARTY->display('module:info:setup_changes.html');
	}
	
	function module_submit_changes_save()
	{
		global $DB, $LMS;
		$userchanges = $_POST['userchanges'];
		if(isset($userchanges))
			foreach($userchanges as $changeid)
			{
				$changes = $DB->GetRow('SELECT customerid, fieldname, fieldvalue FROM up_info_changes
					WHERE id = ?', array($changeid));
				
				if(version_compare($LMS->_version, '1.6.99')>0)
					$customer = $LMS->GetCustomer($changes['customerid']);
				else
					$customer = $LMS->GetUser($changes['customerid']);
					
				$customer[$changes['fieldname']] = $changes['fieldvalue'];
				
				if(version_compare($LMS->_version, '1.6.99')>0)
					$LMS->CustomerUpdate($customer);
				else
				{
					$customer['gguin'] = $customer['im'] ? $customer['im'] : $customer['gguin'];
					$customer['nip'] = $customer['ten'] ? $customer['ten'] : $customer['nip'];
					$customer['pesel'] = $customer['ssn'] ? $customer['ssn'] : $customer['pesel'];
					$LMS->UserUpdate($customer);
				}
			
				$DB->Execute('DELETE FROM up_info_changes WHERE id = ?', array($changeid));
			}
		module_changes();
	}
	
	function module_submit_changes_delete()
	{
		global $DB;
		$userchanges=$_POST['userchanges'];
		if(isset($userchanges))
			foreach($userchanges as $changeid)
				$DB->Execute('DELETE FROM up_info_changes WHERE id = ?', array($changeid));
		module_changes();
	}
	
	function module_setup()
	{
		global $SMARTY, $LMS;
		
		$SMARTY->assign('hide_nodesbox', $LMS->CONFIG['userpanel']['hide_nodesbox']);
    		$SMARTY->display('module:info:setup.html');
        }
	
	function module_submit_setup()
	{
		global $DB;
		
		$DB->Execute('UPDATE uiconfig SET value = ? WHERE section = \'userpanel\' AND var = \'hide_nodesbox\'', array(isset($_POST['hide_nodesbox']) ? 1 : 0));
		header('Location: ?m=userpanel&module=info');
	}
}

?>
